(* See developper doc *)

(** A custom type carrying more information than just loops/doesn't loop *)
type 'a t = 'a * int option

module type LoopingMap =
  sig
    (** Type of the ``relevant'' data. *)
    type loopable

    (** Type of a set of loopable datas. *)
    type 'a t

    val empty : 'a t
    val add   : 'a t -> key : loopable -> data : 'a -> 'a t
    (* TODO provide a ~f *)

    (** Does the data loops with one data among the set of datas?
     * Returns the pair of looping information and the set of loopables that *did not loop*
     *)
    val find : 'a t -> key:loopable -> 'a option
  end
